workfile chap2 m 1871:1 2020:12 
'---------------------------------------------------
'Import data and transform
'----------------------------------------------------
smpl @first @last
read( c9, s=Data ) "ie_data.xls" 10
delete fraction*
delete date*
pagerename untitled monthly
genr lp=log(p)
genr divm=div/12
genr ld=log(divm)
genr dp=divm/p
genr ldp=log(dp)
genr lcpi=log(cpi)
genr infl=d(lcpi)
genr b10Y_ytm=gs10/100
'linearization parameters
scalar dp_bar=@mean(dp)
scalar rho= (1/dp_bar)/(1+1/dp_bar)
scalar k= -log(1-rho)-rho*log((1/(1-rho))-1)
'log monthly stock returns 
genr ret_m_lw=d(lp)
genr ret_m_lc=log((p+divm)/p(-1))
genr ret_m_ll=k-rho*ldp+(ld-ld(-1))+ldp(-1)
'linear monthly stock returns
genr ret_m_w=(p/p(-1))-1
genr ret_m_c=((p+divm)/p(-1))-1
'log monthly returns on long term bonds
genr b10Y_ytm_ll=log(1+b10Y_ytm/12)
genr rho_b=1/( 1+b10Y_ytm) ' this can be substituted by the average as a parm 
genr dur= 12*(1-rho_b^10)/(1-rho_b)
genr ret_b10Y_m_ll=dur(-1)*b10Y_ytm_ll(-1)-(dur(-1)-1)* b10Y_ytm_ll

'returns at different frequencies 
'log returns
genr ret_1y_lc=@msum(ret_m_lc,12)
genr ret_10y_lc=@msum(ret_m_lc,120)
genr ret_10y_lca=ret_10y_lc*0.1
'exact returns 
genr ret_1y_c=(1+ret_m_c)*(1+ret_m_c(-1))*(1+ret_m_c(-2))*(1+ret_m_c(-3))*(1+ret_m_c(-4))*(1+ret_m_c(-5))*(1+ret_m_c(-6))*(1+ret_m_c(-7))*(1+ret_m_c(-8))*(1+ret_m_c(-9))*(1+ret_m_c(-10))*(1+ret_m_c(-11))  -1

genr ret_10y_c=(1+ret_1y_c)*(1+ret_1y_c(-12))*(1+ret_1y_c(-24))*(1+ret_1y_c(-36))*(1+ret_1y_c(-48))*(1+ret_1y_c(-60))*(1+ret_1y_c(-72))*(1+ret_1y_c(-84))*(1+ret_1y_c(-96))*(1+ret_1y_c(-108)) -1

genr ret_10y_ca=(1+ret_10y_c)^0.1 -1

'---------------------------------------------------
'Analyzing returns and historycal performance 
'----------------------------------------------------
smpl 1948:1 1948:1
genr Port_w=1
genr Port_c=1
genr Port_b=1

smpl 1948:2 2013:11
Port_w=Port_w(-1)*(1+ret_m_w)
Port_c=Port_c(-1)*(1+ret_m_c)
Port_b=Port_b(-1)*(1+ret_b10Y_m_ll)
 
include "figure1.prg"
include "figure2.prg"
include "figure3.prg"
include "figure4.prg"
group grp_ret ret_m_lw ret_m_lc ret_m_ll
freeze(Table_1) grp_ret.stats 
freeze(Table_2) grp_ret.cor

'---------------------------------------------------
'Monte-Carlo and Bootstrap 
'----------------------------------------------------
include "section2.prg"

'---------------------------------------------------
'10-year investment performance 
'----------------------------------------------------
include "figure6.prg"
include "figure7.prg"


