'programme to simulate series with Monte Carlo and bootstrap
'Monte-Carlo
delete gxmc* gxbt* gymc* gybt* gx_mc* gx_bt* gy_mc* gy_bt*
smpl 1880:1 2013:9
scalar vol=@stdev(ret_m_c)
scalar alpha=@mean(ret_m_c)
scalar reps=999 
smpl 1948:1 1948:1
series y_mc=1
series x_mc=alpha
series y_bt=1
series x_bt=alpha
group gx_mc 
group gx_bt
group gy_mc
group gy_bt


for !i=1 to reps
smpl 1948:2 2013:9
genr u=nrnd
genr res=ret_m_c-alpha
res.resample

model mc
mc.append x_mc=alpha+vol*u
mc.append y_mc=(1+x_mc)*y_mc(-1)
mc.append assign @all _f{!i}

model bt 
bt.append x_bt=alpha+res_b
bt.append y_bt=(1+x_bt)*y_bt(-1)
bt.append assign @all _f{!i}

mc.solve
bt.solve
gx_mc.add x_mc_f{!i}
gx_bt.add x_bt_f{!i}
gy_mc.add y_mc_f{!i}
gy_bt.add y_bt_f{!i}
next 

stom(gx_mc,gxmc)
stom(gx_bt,gxbt)
stom(gy_mc,gymc)
stom(gy_bt,gybt)
delete x_bt_* y_bt_* x_mc_* y_mc_* gy_bt* gy_mc* gx_bt* gx_mc*

vector(gxbt.@rows) x_bt_q95
vector(gybt.@rows) y_bt_q95
vector(gxmc.@rows) x_mc_q95
vector(gymc.@rows) y_mc_q95
vector(gxbt.@rows) x_bt_q05
vector(gybt.@rows) y_bt_q05
vector(gxmc.@rows) x_mc_q05
vector(gymc.@rows) y_mc_q05

for !i=1 to gxbt.@rows

x_bt_q95(!i)= @quantile(gxbt.@row(!i), .95)
y_bt_q95(!i)= @quantile(gybt.@row(!i), .95)
x_mc_q95(!i)= @quantile(gxmc.@row(!i), .95)
y_mc_q95(!i)= @quantile(gymc.@row(!i), .95)

x_bt_q05(!i)= @quantile(gxbt.@row(!i), .05)
y_bt_q05(!i)= @quantile(gybt.@row(!i), .05)
x_mc_q05(!i)= @quantile(gxmc.@row(!i), .05)
y_mc_q05(!i)= @quantile(gymc.@row(!i), .05)
next

delete s1*
sample s1 1948:2 2013:9
mtos(x_mc_q05,x_mc_05,s1)
mtos(x_mc_q95,x_mc_95,s1)
mtos(x_bt_q05,x_bt_05,s1)
mtos(x_bt_q95,x_bt_95,s1)
mtos(y_mc_q05,y_mc_05,s1)
mtos(y_mc_q95,y_mc_95,s1)
mtos(y_bt_q05,y_bt_05,s1)
mtos(y_bt_q95,y_bt_95,s1)

'graphs 

%type="figure5"
smpl 1948:2 2014:6
delete {%type}*
	graph {%type}.line port_c y_bt_05 y_bt_95
	{%type}.axis grid zeroline
	{%type}.option linepat	' need to set linepat
	'{%type}.draw(line,left,rgb(180,180,180)) 0
	{%type}.elem(1) lcolor(red) lpat(solid)  lwidth(1.25) 'symbol(circle) symbolsize(s)
	{%type}.elem(2) lcolor(blue) lpat(solid) lwidth(1.25)
	{%type}.elem(3) lcolor(green) lpat(dash2) lwidth(1.25)
	{%type}.name(1) actual  
	{%type}.name(2) .05 bound simulated BT
	{%type}.name(3) .95 bound simulated BT
	{%type}.addtext(t)  "actual and simulated cumulative returns "
	'{%type}.axis(l) grid zeroline range(0,6)
		'{%type}.legend columns(1) position(r)
               ' {%type}.draw(shade,bottom) 1970 1985
             ' {%type}.draw(line,bottom) 1991
			'{%type}.draw(line,bottom) 1999



